#include <string.h>

static void inline byte_bcopy(const char *src, char *dest, size_t n)
{
    while (n-- > 0) {
	*dest++ = *src++;
    }
}

void bcopy(const char *src, char *dest, size_t n)
{
    /* spend some effort only on long copies */
    if (n > 16 && ((long)dest & 3) == ((long)src & 3)) {
	/* copy until dest is long-aligned */
	while ((((long)dest) & 3) != 0) {
	    *dest++ = *src++;
	    --n;
	}

	/* now copy long words */
	while (n > 4) {
	    *(long *)dest = *(const long *)src;
	    dest += 4;
	    src += 4;
	    n -= 4;
	}
    }

    /* copy what's left */
    byte_bcopy(src, dest, n);
}
