// Emacs style mode select   -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id: m_fixed.h,v 1.1.1.1 1999/12/20 14:23:41 ersmith Exp $
//
// Copyright (C) 1993-1996 by id Software, Inc.
//
// This source is available for distribution and/or modification
// only under the terms of the DOOM Source Code License as
// published by id Software. All rights reserved.
//
// The source is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License
// for more details.
//
// DESCRIPTION:
//	Fixed point arithemtics, implementation.
//
//-----------------------------------------------------------------------------


#ifndef __M_FIXED__
#define __M_FIXED__


#ifdef __GNUG__
#pragma interface
#endif


//
// Fixed point, 32bit as 16.16.
//
#define FRACBITS		16
#define FRACUNIT		(1<<FRACBITS)

typedef int fixed_t;

#ifdef MERLIN
#include <nuon/mutil.h>
#define FixedMul(a,b) FixMul(a,b,FRACBITS)
#else
fixed_t FixedMul	(fixed_t a, fixed_t b);
#endif
fixed_t FixedDiv	(fixed_t a, fixed_t b);
fixed_t FixedDiv2	(fixed_t a, fixed_t b);

#endif
//-----------------------------------------------------------------------------
//
// $Log: m_fixed.h,v $
// Revision 1.1.1.1  1999/12/20 14:23:41  ersmith
// Initial import of the VMLabs version of Doom
//
//
//-----------------------------------------------------------------------------
