// Emacs style mode select   -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id: m_swap.h,v 1.1.1.1 1999/12/20 14:23:41 ersmith Exp $
//
// Copyright (C) 1993-1996 by id Software, Inc.
//
// This source is available for distribution and/or modification
// only under the terms of the DOOM Source Code License as
// published by id Software. All rights reserved.
//
// The source is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License
// for more details.
//
// DESCRIPTION:
//	Endianess handling, swapping 16bit and 32bit.
//
//-----------------------------------------------------------------------------


#ifndef __M_SWAP__
#define __M_SWAP__


#ifdef __GNUG__
#pragma interface
#endif


// Endianess handling.
// WAD files are stored little endian.
#ifdef __BIG_ENDIAN__
extern inline unsigned short
SwapSHORT(unsigned short s)
{
    return ((s & 0x00ff) << 8) | ((s >> 8) & 0x00ff);
}

extern inline unsigned long
SwapLONG(unsigned long s)
{
    return ((s & 0x00ff) << 24) | 
	(((s >> 8) & 0x00ff) << 16) |
	(((s >> 16) & 0x00ff) << 8) |
	(((s >> 24) & 0x00ff));
}

#define SHORT(x)	((short)SwapSHORT((unsigned short) (x)))
#define LONG(x)         ((long)SwapLONG((unsigned long) (x)))

#else
#define SHORT(x)	(x)
#define LONG(x)         (x)
#endif




#endif
//-----------------------------------------------------------------------------
//
// $Log: m_swap.h,v $
// Revision 1.1.1.1  1999/12/20 14:23:41  ersmith
// Initial import of the VMLabs version of Doom
//
//
//-----------------------------------------------------------------------------
